
i2c_start equ $083C
i2c_write equ $0846
i2c_read  equ $086F
i2c_readlast equ $08BB
i2c_stop  equ $08E5

; 92 = Wert
; 94 = Addresse

        org $101
get     bsr swr4f
        bsr chkrxd
        asla
        asla
        asla
        asla
        sta $93
        bsr rdpulse
        bsr chkrxd
        and #$0F
        ora $93
        sta $91
        bsr rdpulse
        lda $91
        sta $92
        clr $91
        bra coneeprom
        
start92 bsr rdlast
        ldx $92
        bra i2cstrt

chkrxd  bsr strt92r
rxdloop bsr read91
        brclr 6,$91,rxdloop
        rts

strt92r ldx $92
startr  incx
        bra i2cstrt

rdpulse bsr start92
        ldx #$5F
        jsr i2c_write
wr4f    ldx #$4F
wrlast  jsr i2c_write
        jsr i2c_stop
        rts

read91  jsr i2c_read
        sta $91
        rts
        
chkrdy  ldx $94
        bsr startr
rdyloop bsr read91
        brset 6,$91,rdyloop
rdlast  jsr i2c_readlast
        rts        

swr4f   bsr start92
        bra wr4f

put     bsr rdlast
        ldx $94
        bsr swr6f
        bsr chkrdy
        lda $92
        asra
        asra
        asra
        asra
        bsr wrpulse
        bsr chkrdy
        lda $92
        bsr wrpulse
        ;bra coneeprom
        
coneeprom ;EEProm anmelden
        ldx #$0A0
        bsr i2cstrt
        ldx $066
        jsr i2c_write
        ldx $067
        jsr i2c_write
        ldx #$0A1
i2cstrt jsr i2c_start
        rts

reset   bsr start92
        ldx#$CF
        jsr i2c_write
        bsr wr4f
        bra coneeprom

swr6f   bsr i2cstrt
        ldx #$6F
        bra wrlast
        
rdstat  bsr strt92r
        bsr read91
        bsr rdlast
        clra
        rts

wrpulse and #$0F
        ora #$60
        sta $93
        ldx $94
        bsr i2cstrt
        ldx $93
        jsr i2c_write
        lda $93
        ora #$10
        tax
        jsr i2c_write
        ldx $93
        bra wrlast

rxd     bsr swr4f
        bsr rdstat
        brclr 6,$91,stnrdy
strdy   lda #$FF
stnrdy  sta $92        
        sta $91
        bra coneeprom
        
ready   bsr rdlast
        ldx $92
        bsr swr6f
        bsr rdstat
        brset 6,$92,stnrdy
        bra strdy
       
        
        

