'*****************************************************
'* CC1-Basic Test/Beispiel-Programm fr              *
'* den IC-Koppler (interner IC-Bus)                *
'* CCTools 2003                                      *
'*****************************************************
' Es werden alle an der seriellen Schnittstelle
' empfangenen Daten an den IC-Koppler gesendet
' und alles, was vom IC-Koppler empfangen wird,
' ber die serielle Schnittstelle ausgegeben
'

'Einsprungadressen
define i2ckopRST &h183 'RESET/INIT + Sendepuffer lschen
define i2ckopRXD &h1b7 'auf Daten prfen
define i2ckopRDY &h1c6 'auf Sendebereitschaft prfen
define i2ckopPUT &h159 'Byte senden
define i2ckopGET &h101 'Byte empfangen

'IC-Bus Adresse des IC-kopplers
define i2ckop 64 ' Adresse des PCF8574 je nach Art und Jumperstellung
                 ' PCF8574 :  64 bis  78 (nur gerade Adressen !!!)
                 ' PCF8574A: 112 bis 124 (nur gerade Adressen !!!)

define data byte[1]
gosub i2ckop_init
put 12
print "CCTools IC-Koppler Beispiel"
print "CCTools 2003"
print
#loop
 if not i2ckop_rxd then goto next
    data=i2ckop_get
    put data
    if data=13 then put 10 'Workaround fr Hyperterminal
 #next
 if not rxd then goto loop
    get data
    sys i2ckopPUT, i2ckop, data
goto loop


#I2Ckop_GET ' Byte von IC-Koppler lesen
sys i2ckopGET, i2ckop
return
#I2Ckop_RXD ' Auf empfangene Daten prfen
sys i2ckopRXD, i2ckop
return
#I2Ckop_READY ' Auf Sendebereitschaft prfen
sys i2ckopRDY, i2ckop
return
#I2Ckop_Init
sys i2ckopRST, i2ckop
return

' sys i2ckopPUT, i2ckop, data ' Byte an den IC-Koppler senden



syscode "i2ckop.s19" ' Nur einmal laden, dann auskommentieren
